Index: Singular/blackbox.h
===================================================================
--- Singular/blackbox.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/blackbox.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -6,5 +6,4 @@
 
 #include <kernel/structs.h>
-#include <Singular/febase.h>
 
 #include <Singular/lists.h>
Index: Singular/calcSVD.cc
===================================================================
--- Singular/calcSVD.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/calcSVD.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -12,5 +12,4 @@
 #include <polys/matpol.h>
 #include <Singular/lists.h>
-#include <Singular/febase.h>
 
 template class std::vector< amp::mpfr_record* >;
Index: Singular/countedref.h
===================================================================
--- Singular/countedref.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/countedref.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -23,5 +23,4 @@
 #include <omalloc/omalloc.h>
 #include <kernel/structs.h>
-#include <Singular/febase.h>
 #include "subexpr.h"
 #include "idrec.h"
Index: Singular/eigenval_ip.cc
===================================================================
--- Singular/eigenval_ip.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/eigenval_ip.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -13,5 +13,4 @@
 #ifdef HAVE_EIGENVAL
 
-#include <Singular/febase.h>
 #include <Singular/tok.h>
 #include <Singular/ipid.h>
Index: Singular/extra.cc
===================================================================
--- Singular/extra.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/extra.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -54,4 +54,5 @@
 
 
+#include <resources/feResource.h>
 #include <polys/monomials/ring.h>
 #include <kernel/polys.h>
@@ -68,5 +69,4 @@
 #include <kernel/digitech.h>
 #include <kernel/GBEngine/stairc.h>
-#include <Singular/febase.h>
 #include <kernel/ideals.h>
 #include <kernel/GBEngine/kstd1.h>
Index: Singular/febase.h
===================================================================
--- Singular/febase.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/febase.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -13,16 +13,4 @@
 
 #include <kernel/structs.h>
-
-enum   feBufferTypes
-{
-  BT_none  = 0,  // entry level
-  BT_break = 1,  // while, for
-  BT_proc,       // proc
-  BT_example,    // example
-  BT_file,       // <"file"
-  BT_execute,    // execute
-  BT_if,         // if
-  BT_else        // else
-};
 
 enum   feBufferInputs
@@ -43,10 +31,7 @@
 };  /* for scanner.l */
 
-extern int myynest;
 extern int yylineno;
 extern char     my_yylinebuf[80];
 extern char    prompt_char; /*1 either '>' or '.'*/
-extern int    si_echo;
-extern int    printlevel;
 
 #ifdef __cplusplus
@@ -54,57 +39,8 @@
 /* the C++-part: */
 
-typedef enum { LANG_NONE, LANG_TOP, LANG_SINGULAR, LANG_C, LANG_MAX} language_defs;
 // LANG_TOP     : Toplevel package only
 // LANG_SINGULAR:
 // LANG_C       :
 //
-
-class proc_singular
-{
-public:
-  long   proc_start;       // position where proc is starting
-  long   def_end;          // position where proc header is ending
-  long   help_start;       // position where help is starting
-  long   help_end;         // position where help is starting
-  long   body_start;       // position where proc-body is starting
-  long   body_end;         // position where proc-body is ending
-  long   example_start;    // position where example is starting
-  long   proc_end;         // position where proc is ending
-  int    proc_lineno;
-  int    body_lineno;
-  int    example_lineno;
-  char   *body;
-  long help_chksum;
-};
-
-struct proc_object
-{
-//public:
-  BOOLEAN (*function)(leftv res, leftv v);
-};
-union uprocinfodata
-{
-public:
-  proc_singular  s;        // data of Singular-procedure
-  struct proc_object    o; // pointer to binary-function
-};
-
-typedef union uprocinfodata procinfodata;
-
-class procinfo;
-typedef procinfo *         procinfov;
-
-class procinfo
-{
-public:
-  char          *libname;
-  char          *procname;
-  package       pack;
-  language_defs language;
-  short         ref;
-  char          is_static;        // if set, proc not accessible for user
-  char          trace_flag;
-  procinfodata  data;
-};
 
 class Voice
Index: Singular/fevoices.cc
===================================================================
--- Singular/fevoices.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/fevoices.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -14,4 +14,6 @@
 #include <reporter/reporter.h>
 #include <Singular/febase.h>
+#include <Singular/subexpr.h>
+#include <Singular/ipshell.h>
 
 #include <stdlib.h>
Index: Singular/fglm.cc
===================================================================
--- Singular/fglm.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/fglm.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -27,5 +27,4 @@
 #include <polys/monomials/maps.h>
 
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/ideals.h>
Index: Singular/gms.cc
===================================================================
--- Singular/gms.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/gms.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -17,5 +17,4 @@
 #include <coeffs/numbers.h>
 #include <kernel/polys.h>
-#include <Singular/febase.h>
 
 #include "ipid.h"
Index: Singular/ipassign.cc
===================================================================
--- Singular/ipassign.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipassign.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -37,5 +37,4 @@
 #include <polys/nc/sca.h>
 
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/ideals.h>
Index: Singular/ipconv.cc
===================================================================
--- Singular/ipconv.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipconv.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -15,5 +15,4 @@
 #include <misc/options.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/ideals.h>
Index: Singular/ipid.cc
===================================================================
--- Singular/ipid.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipid.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -24,5 +24,4 @@
 #include <polys/monomials/ring.h>
 
-#include <Singular/febase.h>
 #include <libpolys/coeffs/longrat.h>
 #include <kernel/polys.h>
@@ -32,4 +31,5 @@
 #include <Singular/tok.h>
 #include <Singular/ipshell.h>
+#include <Singular/febase.h>
 #include <Singular/lists.h>
 #include <Singular/attrib.h>
Index: Singular/iplib.cc
===================================================================
--- Singular/iplib.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/iplib.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -16,8 +16,8 @@
 #include <Singular/ipid.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 #include <polys/monomials/ring.h>
 #include <Singular/subexpr.h>
 #include <Singular/ipshell.h>
+#include <Singular/febase.h>
 #include <Singular/lists.h>
 
Index: Singular/ipprint.cc
===================================================================
--- Singular/ipprint.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipprint.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -16,5 +16,4 @@
 #include <polys/matpol.h>
 
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/ideals.h>
Index: Singular/ipshell.cc
===================================================================
--- Singular/ipshell.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipshell.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -23,5 +23,4 @@
 #include <misc/intvec.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <coeffs/numbers.h>
@@ -32,4 +31,5 @@
 #include <polys/monomials/ring.h>
 #include <Singular/subexpr.h>
+#include <Singular/febase.h>
 #include <polys/monomials/maps.h>
 #include <kernel/GBEngine/syz.h>
Index: Singular/ipshell.h
===================================================================
--- Singular/ipshell.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/ipshell.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -34,4 +34,8 @@
 extern const char *lastreserved;
 extern const char *singular_date; /* tesths.cc, set by final compile */
+extern int myynest;
+extern int printlevel;
+extern int si_echo;
+
 
 extern BOOLEAN yyInRingConstruction; /* 1: during ring construction */
Index: Singular/libparse.cc
===================================================================
--- Singular/libparse.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/libparse.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -1073,5 +1073,4 @@
   #include <Singular/tok.h>
   #include <misc/options.h>
-  #include <Singular/febase.h>
   #include <omalloc/omalloc.h>
 #endif
Index: Singular/libparse.h
===================================================================
--- Singular/libparse.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/libparse.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -71,6 +71,4 @@
   procinfodata  data;
 };
-#else
-#include <Singular/febase.h>
 #endif
 
Index: Singular/libparse.ll
===================================================================
--- Singular/libparse.ll	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/libparse.ll	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -21,5 +21,4 @@
   #include <Singular/tok.h>
   #include <misc/options.h>
-  #include <Singular/febase.h>
   #include <omalloc/omalloc.h>
 #endif
Index: Singular/links/asciiLink.cc
===================================================================
--- Singular/links/asciiLink.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/links/asciiLink.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -10,5 +10,4 @@
 #include <misc/options.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 
 #include <Singular/tok.h>
@@ -16,4 +15,6 @@
 #include <Singular/ipshell.h>
 #include <Singular/ipid.h>
+#include <Singular/febase.h>
+#include <Singular/ipshell.h>
 #include <Singular/links/silink.h>
 
Index: Singular/links/silink.cc
===================================================================
--- Singular/links/silink.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/links/silink.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -18,5 +18,4 @@
 #include <polys/monomials/ring.h>
 
-#include <Singular/febase.h>
 #include <kernel/ideals.h>
 
Index: Singular/links/sing_dbm.cc
===================================================================
--- Singular/links/sing_dbm.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/links/sing_dbm.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -18,5 +18,4 @@
 
 #  include <omalloc/omalloc.h>
-#  include <Singular/febase.h>
 #  include <Singular/tok.h>
 #  include <Singular/ipid.h>
Index: Singular/links/ssiLink.cc
===================================================================
--- Singular/links/ssiLink.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/links/ssiLink.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -35,4 +35,5 @@
 #include <Singular/lists.h>
 #include <Singular/blackbox.h>
+#include <Singular/febase.h>
 #include <Singular/links/ssiLink.h>
 
Index: Singular/lists.cc
===================================================================
--- Singular/lists.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/lists.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -13,5 +13,4 @@
 #include <kernel/mod2.h>
 #include <Singular/tok.h>
-#include <Singular/febase.h>
 //#include "ipid.h"
 #include <kernel/polys.h>
Index: Singular/locals.h
===================================================================
--- Singular/locals.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/locals.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -7,5 +7,4 @@
 #include <Singular/ipid.h>
 //#include <mmemory.h>
-#include <Singular/febase.h>
 #include <Singular/subexpr.h>
 //#include <utils.h>
Index: Singular/maps_ip.cc
===================================================================
--- Singular/maps_ip.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/maps_ip.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -25,5 +25,4 @@
 // #include <kernel/longalg.h>
 
-#include <Singular/febase.h>
 #include <kernel/GBEngine/kstd1.h>
 
Index: Singular/misc_ip.cc
===================================================================
--- Singular/misc_ip.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/misc_ip.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -384,7 +384,7 @@
 #include <polys/templates/p_Procs.h>
 
-#include <Singular/febase.h>
 #include <kernel/GBEngine/kstd1.h>
 #include <Singular/timer.h>
+#include <Singular/febase.h>
 
 
Index: Singular/pcv.cc
===================================================================
--- Singular/pcv.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/pcv.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -21,5 +21,4 @@
 #include <Singular/lists.h>
 #include <polys/matpol.h>
-#include <Singular/febase.h>
 #include <Singular/pcv.h>
 
Index: Singular/pyobject.cc
===================================================================
--- Singular/pyobject.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/pyobject.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -19,6 +19,4 @@
 #include <misc/intvec.h>
 
-#include <Singular/febase.h>
-
 #include <Singular/subexpr.h>
 #include <Singular/ipid.h>
@@ -28,4 +26,5 @@
 #include <Singular/ipshell.h>
 #include <Singular/newstruct.h>
+#include <Singular/febase.h>
 
 #include <Singular/mod_lib.h>
Index: Singular/pyobject_setup.cc
===================================================================
--- Singular/pyobject_setup.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/pyobject_setup.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -18,5 +18,4 @@
 
 #include <kernel/mod2.h>
-#include <Singular/febase.h>
 #include <Singular/blackbox.h>
 #include <Singular/ipshell.h>
Index: Singular/sdb.cc
===================================================================
--- Singular/sdb.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/sdb.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -11,9 +11,8 @@
 #include <reporter/si_signals.h>
 
-#include <Singular/febase.h>
-
 #include <Singular/tok.h>
 #include <Singular/ipshell.h>
 #include <Singular/ipid.h>
+#include <Singular/febase.h>
 #include <Singular/sdb.h>
 
Index: Singular/sdb.h
===================================================================
--- Singular/sdb.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/sdb.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -11,5 +11,4 @@
 
 #ifdef HAVE_SDB
-#include <Singular/febase.h>
 #include <kernel/structs.h>
 
Index: Singular/singmathic.cc
===================================================================
--- Singular/singmathic.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/singmathic.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -6,5 +6,4 @@
 #include <misc/options.h>
 
-#include <Singular/febase.h>
 #include <kernel/ideals.h>
 #include <kernel/polys.h>
Index: Singular/subexpr.cc
===================================================================
--- Singular/subexpr.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/subexpr.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -26,5 +26,4 @@
 // #include <coeffs/longrat.h>
 
-#include <Singular/febase.h>
 #include <kernel/ideals.h>
 #include <kernel/GBEngine/kstd1.h>
Index: Singular/subexpr.h
===================================================================
--- Singular/subexpr.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/subexpr.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -12,10 +12,56 @@
 #include <polys/monomials/ring.h>
 
-#include <Singular/febase.h>
-//#include <kernel/structs.h>
+//#include <Singular/ipid.h>
 
 #include <Singular/grammar.h>
 #include <Singular/tok.h>
 #include <Singular/attrib.h>
+
+typedef enum { LANG_NONE, LANG_TOP, LANG_SINGULAR, LANG_C, LANG_MAX} language_defs;
+class proc_singular
+{
+public:
+  long   proc_start;       // position where proc is starting
+  long   def_end;          // position where proc header is ending
+  long   help_start;       // position where help is starting
+  long   help_end;         // position where help is starting
+  long   body_start;       // position where proc-body is starting
+  long   body_end;         // position where proc-body is ending
+  long   example_start;    // position where example is starting
+  long   proc_end;         // position where proc is ending
+  int    proc_lineno;
+  int    body_lineno;
+  int    example_lineno;
+  char   *body;
+  long help_chksum;
+};
+struct proc_object
+{
+//public:
+  BOOLEAN (*function)(leftv res, leftv v);
+};
+
+union uprocinfodata
+{
+public:
+  proc_singular  s;        // data of Singular-procedure
+  struct proc_object    o; // pointer to binary-function
+};
+typedef union uprocinfodata procinfodata;
+
+class procinfo
+{
+public:
+  char          *libname;
+  char          *procname;
+  package       pack;
+  language_defs language;
+  short         ref;
+  char          is_static;        // if set, proc not accessible for user
+  char          trace_flag;
+  procinfodata  data;
+};
+
+typedef procinfo *         procinfov;
 
 struct _ssubexpr
Index: Singular/timer.cc
===================================================================
--- Singular/timer.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/timer.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -52,6 +52,6 @@
 
 
+#include <libpolys/reporter/reporter.h>
 #include <Singular/timer.h>
-#include <Singular/febase.h>
 
 /*3
Index: Singular/walk.cc
===================================================================
--- Singular/walk.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/walk.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -40,5 +40,4 @@
 #include <misc/options.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 #include <Singular/ipshell.h>
 #include <Singular/ipconv.h>
@@ -62,5 +61,4 @@
 #include <Singular/ipid.h>
 #include <Singular/tok.h>
-#include <Singular/febase.h>
 #include <coeffs/numbers.h>
 #include <Singular/ipid.h>
Index: Singular/walk_ip.cc
===================================================================
--- Singular/walk_ip.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/walk_ip.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -12,5 +12,4 @@
 #include <misc/intvec.h>
 #include <omalloc/omalloc.h>
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/ideals.h>
Index: Singular/wrapper.cc
===================================================================
--- Singular/wrapper.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ Singular/wrapper.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -2,5 +2,4 @@
 #include <polys/monomials/ring.h>
 
-#include <Singular/febase.h>
 #include <kernel/polys.h>
 #include <kernel/GBEngine/kstd1.h>
Index: dyn_modules/bigintm/bigintm.cc
===================================================================
--- dyn_modules/bigintm/bigintm.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ dyn_modules/bigintm/bigintm.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -8,6 +8,4 @@
 #include <coeffs/coeffs.h>
 #include <coeffs/longrat.h>
-
-#include <Singular/febase.h>
 
 #include <Singular/ipid.h>
Index: dyn_modules/syzextra/DebugPrint.cc
===================================================================
--- dyn_modules/syzextra/DebugPrint.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ dyn_modules/syzextra/DebugPrint.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -27,5 +27,4 @@
 #include <polys/monomials/p_polys.h>
 
-#include <Singular/febase.h>
 #include <kernel/ideals.h>
 
Index: dyn_modules/syzextra/myNF.cc
===================================================================
--- dyn_modules/syzextra/myNF.cc	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ dyn_modules/syzextra/myNF.cc	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -34,5 +34,4 @@
 
 #include <kernel/structs.h>
-#include <Singular/febase.h>
 
 
Index: kernel/structs.h
===================================================================
--- kernel/structs.h	(revision 4676d5eca0f4ac138d3c85099b1c244a3d695016)
+++ kernel/structs.h	(revision 72a01ef638e8b3a810e91a03cffe9f926b9511e4)
@@ -29,4 +29,5 @@
 #include <polys/coeffrings.h>
 
+class Voice;
 class sleftv;
 class procinfo;
@@ -44,4 +45,16 @@
   isHomog    = TRUE,
   testHomog
+};
+
+enum   feBufferTypes
+{
+  BT_none  = 0,  // entry level
+  BT_break = 1,  // while, for
+  BT_proc,       // proc
+  BT_example,    // example
+  BT_file,       // <"file"
+  BT_execute,    // execute
+  BT_if,         // if
+  BT_else        // else
 };
 