Index: omalloc/configure
===================================================================
--- omalloc/configure	(revision 682c0fc669c618482ee7213a8a2e691bed6a4d54)
+++ omalloc/configure	(revision 78f1abdf266970a5405d91d6d5ff1bb269c7cb34)
@@ -1287,8 +1287,10 @@
   { echo "configure: error: *** ar program not found" 1>&2; exit 1; }
 fi
-# Extract the first word of "perl", so it can be a program name with args.
-set dummy perl; ac_word=$2
+for ac_prog in perl
+do
+# Extract the first word of "$ac_prog", so it can be a program name with args.
+set dummy $ac_prog; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1293: checking for $ac_word" >&5
+echo "configure:1295: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_PERL'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1302,10 +1304,9 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
-      ac_cv_prog_PERL="perl"
+      ac_cv_prog_PERL="$ac_prog"
       break
     fi
   done
   IFS="$ac_save_ifs"
-  test -z "$ac_cv_prog_PERL" && ac_cv_prog_PERL=":"
 fi
 fi
@@ -1317,5 +1318,9 @@
 fi
 
-if test "$ac_cv_prog_PERL" != perl; then
+test -n "$PERL" && break
+done
+test -n "$PERL" || PERL=""no""
+
+if test "$ac_cv_prog_PERL" = no; then
   { echo "configure: error: *** perl program not found" 1>&2; exit 1; }
 fi
@@ -1324,5 +1329,5 @@
 set dummy addr2line; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1327: checking for $ac_word" >&5
+echo "configure:1332: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_ADDR2LINE'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1359,10 +1364,10 @@
 
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1362: checking for ANSI C header files" >&5
+echo "configure:1367: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1367 "configure"
+#line 1372 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1372,5 +1377,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1375: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1380: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1389,5 +1394,5 @@
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1392 "configure"
+#line 1397 "configure"
 #include "confdefs.h"
 #include <string.h>
@@ -1407,5 +1412,5 @@
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1410 "configure"
+#line 1415 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1428,5 +1433,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1431 "configure"
+#line 1436 "configure"
 #include "confdefs.h"
 #include <ctype.h>
@@ -1439,5 +1444,5 @@
 
 EOF
-if { (eval echo configure:1442: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1447: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   :
@@ -1466,15 +1471,15 @@
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1469: checking for $ac_hdr" >&5
+echo "configure:1474: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1474 "configure"
+#line 1479 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1479: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1484: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1507,15 +1512,15 @@
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1510: checking for $ac_hdr" >&5
+echo "configure:1515: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1515 "configure"
+#line 1520 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1520: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1525: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1547,10 +1552,10 @@
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:1550: checking for $ac_func" >&5
+echo "configure:1555: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1555 "configure"
+#line 1560 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
@@ -1575,5 +1580,5 @@
 ; return 0; }
 EOF
-if { (eval echo configure:1578: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
+if { (eval echo configure:1583: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
@@ -1603,5 +1608,5 @@
 # sizes
 echo $ac_n "checking size of long""... $ac_c" 1>&6
-echo "configure:1606: checking size of long" >&5
+echo "configure:1611: checking size of long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1611,5 +1616,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1614 "configure"
+#line 1619 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1622,5 +1627,5 @@
 }
 EOF
-if { (eval echo configure:1625: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1630: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long=`cat conftestval`
@@ -1642,5 +1647,5 @@
 
 echo $ac_n "checking size of void*""... $ac_c" 1>&6
-echo "configure:1645: checking size of void*" >&5
+echo "configure:1650: checking size of void*" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_voidp'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1650,5 +1655,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1653 "configure"
+#line 1658 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1661,5 +1666,5 @@
 }
 EOF
-if { (eval echo configure:1664: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1669: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_voidp=`cat conftestval`
@@ -1681,5 +1686,5 @@
 
 echo $ac_n "checking size of double""... $ac_c" 1>&6
-echo "configure:1684: checking size of double" >&5
+echo "configure:1689: checking size of double" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_double'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1689,5 +1694,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1692 "configure"
+#line 1697 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1700,5 +1705,5 @@
 }
 EOF
-if { (eval echo configure:1703: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1708: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_double=`cat conftestval`
@@ -1720,5 +1725,5 @@
 
 echo $ac_n "checking size of size_t""... $ac_c" 1>&6
-echo "configure:1723: checking size of size_t" >&5
+echo "configure:1728: checking size of size_t" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1728,5 +1733,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1731 "configure"
+#line 1736 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1739,5 +1744,5 @@
 }
 EOF
-if { (eval echo configure:1742: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1747: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_size_t=`cat conftestval`
@@ -1770,5 +1775,5 @@
 
 echo $ac_n "checking size of system page""... $ac_c" 1>&6
-echo "configure:1773: checking size of system page" >&5
+echo "configure:1778: checking size of system page" >&5
 if eval "test \"`echo '$''{'ac_cv_pagesize'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1778,5 +1783,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1781 "configure"
+#line 1786 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1791,5 +1796,5 @@
 }
 EOF
-if { (eval echo configure:1794: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1799: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_pagesize=`cat conftestval`
@@ -1817,5 +1822,5 @@
 if test "$ac_cv_func_mmap" = yes; then
 echo $ac_n "checking whether mmap works""... $ac_c" 1>&6
-echo "configure:1820: checking whether mmap works" >&5
+echo "configure:1825: checking whether mmap works" >&5
 if eval "test \"`echo '$''{'ac_cv_working_mmap'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1825,5 +1830,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1828 "configure"
+#line 1833 "configure"
 #include "confdefs.h"
 
@@ -1837,5 +1842,5 @@
 }
 EOF
-if { (eval echo configure:1840: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1845: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_working_mmap=yes
@@ -1861,5 +1866,5 @@
 
 echo $ac_n "checking whether alignment needs to be strict""... $ac_c" 1>&6
-echo "configure:1864: checking whether alignment needs to be strict" >&5
+echo "configure:1869: checking whether alignment needs to be strict" >&5
 if eval "test \"`echo '$''{'ac_cv_align_need_strict'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1869,5 +1874,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1872 "configure"
+#line 1877 "configure"
 #include "confdefs.h"
  
@@ -1884,5 +1889,5 @@
 
 EOF
-if { (eval echo configure:1887: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1892: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_align_need_strict=no
@@ -1901,5 +1906,5 @@
 
 echo $ac_n "checking for external config files""... $ac_c" 1>&6
-echo "configure:1904: checking for external config files" >&5
+echo "configure:1909: checking for external config files" >&5
 if test "${with_external_config_h+set}" = set; then
     cat >> confdefs.h <<\EOF
@@ -1927,5 +1932,5 @@
 
 echo $ac_n "checking which malloc to use""... $ac_c" 1>&6
-echo "configure:1930: checking which malloc to use" >&5
+echo "configure:1935: checking which malloc to use" >&5
 if test "${with_malloc}" = system; then
   OM_MALLOC_HEADER=omMallocSystem.h
@@ -1964,5 +1969,5 @@
 
 echo $ac_n "checking whether malloc provides SizeOfAddr""... $ac_c" 1>&6
-echo "configure:1967: checking whether malloc provides SizeOfAddr" >&5
+echo "configure:1972: checking whether malloc provides SizeOfAddr" >&5
 if test "${ac_cv_malloc_sizeof_addr}" = no; then
   echo "$ac_t""(cached) no" 1>&6
@@ -1974,5 +1979,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1977 "configure"
+#line 1982 "configure"
 #include "confdefs.h"
 
@@ -1991,5 +1996,5 @@
 
 EOF
-if { (eval echo configure:1994: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1999: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_malloc_sizeof_addr="${OM_MALLOC_HEADER}_${OM_MALLOC_SOURCE}"
@@ -2039,5 +2044,5 @@
 
 echo $ac_n "checking whether working valloc exists""... $ac_c" 1>&6
-echo "configure:2042: checking whether working valloc exists" >&5
+echo "configure:2047: checking whether working valloc exists" >&5
 if test "${ac_cv_working_valloc}" = no; then
   echo "$ac_t""(cached) no" 1>&6
@@ -2049,5 +2054,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 2052 "configure"
+#line 2057 "configure"
 #include "confdefs.h"
 
@@ -2067,5 +2072,5 @@
 
 EOF
-if { (eval echo configure:2070: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2075: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_working_valloc="${OM_MALLOC_HEADER}_${OM_MALLOC_SOURCE}"
@@ -2087,5 +2092,5 @@
 
 echo $ac_n "checking which valloc to use""... $ac_c" 1>&6
-echo "configure:2090: checking which valloc to use" >&5
+echo "configure:2095: checking which valloc to use" >&5
 if test "${with_valloc+set}" != set || test "${with_valloc}" = mmap; then
   if test "${ac_cv_working_mmap}" = yes; then
@@ -2112,5 +2117,5 @@
 
 echo $ac_n "checking whether to emulate omalloc""... $ac_c" 1>&6
-echo "configure:2115: checking whether to emulate omalloc" >&5
+echo "configure:2120: checking whether to emulate omalloc" >&5
 if test "${with_emulate_omalloc}" = yes; then
   cat >> confdefs.h <<\EOF
@@ -2124,5 +2129,5 @@
 
 echo $ac_n "checking how to align""... $ac_c" 1>&6
-echo "configure:2127: checking how to align" >&5
+echo "configure:2132: checking how to align" >&5
 if test "$with_align" = 8 || test "$ac_cv_sizeof_long" = 8; then
   ac_cv_align=8
@@ -2145,5 +2150,5 @@
 
 echo $ac_n "checking whether to use dense bins""... $ac_c" 1>&6
-echo "configure:2148: checking whether to use dense bins" >&5
+echo "configure:2153: checking whether to use dense bins" >&5
 if test "$with_dense_bins" = yes; then
 echo "$ac_t""yes" 1>&6
@@ -2157,5 +2162,5 @@
 
 echo $ac_n "checking whether to disable debugging""... $ac_c" 1>&6
-echo "configure:2160: checking whether to disable debugging" >&5
+echo "configure:2165: checking whether to disable debugging" >&5
 if test "$with_debug" != no; then
 echo "$ac_t""no" 1>&6
@@ -2170,5 +2175,5 @@
 
 echo $ac_n "checking whether to have tracking debug functionality""... $ac_c" 1>&6
-echo "configure:2173: checking whether to have tracking debug functionality" >&5
+echo "configure:2178: checking whether to have tracking debug functionality" >&5
 if test "$with_track" != no; then
 echo "$ac_t""yes" 1>&6
@@ -2182,5 +2187,5 @@
 
 echo $ac_n "checking whether to use internal debug""... $ac_c" 1>&6
-echo "configure:2185: checking whether to use internal debug" >&5
+echo "configure:2190: checking whether to use internal debug" >&5
 if test "$with_internal_debug" = yes; then
 echo "$ac_t""yes" 1>&6
@@ -2195,5 +2200,5 @@
 
 echo $ac_n "checking whether to inline""... $ac_c" 1>&6
-echo "configure:2198: checking whether to inline" >&5
+echo "configure:2203: checking whether to inline" >&5
 if test "$ac_cv_c_inline" != no && test "$with_inline" != no; then
   cat >> confdefs.h <<EOF
@@ -2231,5 +2236,5 @@
 
 echo $ac_n "checking whether GET_RET_ADDR works""... $ac_c" 1>&6
-echo "configure:2234: checking whether GET_RET_ADDR works" >&5
+echo "configure:2239: checking whether GET_RET_ADDR works" >&5
 if eval "test \"`echo '$''{'ac_cv_get_return_addr_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -2239,5 +2244,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 2242 "configure"
+#line 2247 "configure"
 #include "confdefs.h"
 
@@ -2255,5 +2260,5 @@
 
 EOF
-if { (eval echo configure:2258: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2263: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_get_return_addr_works=yes
@@ -2278,5 +2283,5 @@
 
 echo $ac_n "checking whether omGetBackTrace works""... $ac_c" 1>&6
-echo "configure:2281: checking whether omGetBackTrace works" >&5
+echo "configure:2286: checking whether omGetBackTrace works" >&5
 if eval "test \"`echo '$''{'ac_cv_get_backtrace_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -2286,5 +2291,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 2289 "configure"
+#line 2294 "configure"
 #include "confdefs.h"
 
@@ -2307,5 +2312,5 @@
 
 EOF
-if { (eval echo configure:2310: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2315: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_get_backtrace_works=yes
@@ -2330,5 +2335,5 @@
 
 echo $ac_n "checking whether addr2line works""... $ac_c" 1>&6
-echo "configure:2333: checking whether addr2line works" >&5
+echo "configure:2338: checking whether addr2line works" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_addr2line_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -2338,5 +2343,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 2341 "configure"
+#line 2346 "configure"
 #include "confdefs.h"
 
@@ -2371,5 +2376,5 @@
 
 EOF
-if { (eval echo configure:2374: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2379: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_prog_addr2line_works=yes
@@ -2388,5 +2393,5 @@
   
 echo $ac_n "checking whether to track return addresses""... $ac_c" 1>&6
-echo "configure:2391: checking whether to track return addresses" >&5
+echo "configure:2396: checking whether to track return addresses" >&5
 if test "$with_track_return" = no || test "$ac_cv_get_return_addr_works" = no || test "$ac_cv_prog_addr2line_works" != yes; then
   with_track_return=no
@@ -2401,5 +2406,5 @@
 
 echo $ac_n "checking whether to track files and line numbers""... $ac_c" 1>&6
-echo "configure:2404: checking whether to track files and line numbers" >&5
+echo "configure:2409: checking whether to track files and line numbers" >&5
 if test "$with_track_fl" = no && test "$with_track_return" = no; then
   with_track_fl=yes
@@ -2421,5 +2426,5 @@
 
 echo $ac_n "checking whether to track stack backtraces""... $ac_c" 1>&6
-echo "configure:2424: checking whether to track stack backtraces" >&5
+echo "configure:2429: checking whether to track stack backtraces" >&5
 if test "$with_track" != no && test "$ac_cv_get_backtrace_works" = yes && test "$with_track_backtrace" != no && test "$ac_cv_prog_addr2line_works" = yes; then
   with_track_backtrace=yes
Index: omalloc/configure.in
===================================================================
--- omalloc/configure.in	(revision 682c0fc669c618482ee7213a8a2e691bed6a4d54)
+++ omalloc/configure.in	(revision 78f1abdf266970a5405d91d6d5ff1bb269c7cb34)
@@ -4,5 +4,5 @@
 dnl Author:  obachman@mathematik.uni-kl.de (Olaf Bachmann)
 dnl Created: 11/99
-dnl Version: $Id: configure.in,v 1.6 2000-08-16 12:55:45 obachman Exp $
+dnl Version: $Id: configure.in,v 1.7 2000-08-18 09:02:01 obachman Exp $
 dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
 
@@ -103,6 +103,6 @@
   AC_MSG_ERROR(*** ar program not found)
 fi
-AC_CHECK_PROG(PERL, perl, perl, :)
-if test "$ac_cv_prog_PERL" != perl; then
+AC_CHECK_PROGS(PERL, perl, "no")
+if test "$ac_cv_prog_PERL" = no; then
   AC_MSG_ERROR(*** perl program not found)
 fi
@@ -121,5 +121,5 @@
 AC_CHECK_HEADERS(unistd.h sys/mman.h fcntl.h /usr/include/malloc.h)
 
-AC_CHECK_FUNCS(popen readlink getcwd getwd mmap sbrk)
+AC_CHECK_FUNCS(popen readlink getcwd getwd mmap sbrk random)
 
 dnl llllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
Index: omalloc/omtTest.c
===================================================================
--- omalloc/omtTest.c	(revision 682c0fc669c618482ee7213a8a2e691bed6a4d54)
+++ omalloc/omtTest.c	(revision 78f1abdf266970a5405d91d6d5ff1bb269c7cb34)
@@ -13,4 +13,18 @@
 int seed;
 
+#if defined (__hpux) || defined (__alpha)  || defined (__svr4__) || defined (__SVR4)
+/* HPUX lacks random().  DEC OSF/1 1.2 random() returns a double.  */
+long mrand48 ();
+void srand48();
+static long
+random ()
+{
+  return mrand48 ();
+}
+static void srandom(long seed)
+{
+  srand48(seed);
+}
+#endif
 
 #if CHECK_LEVEL > 0
@@ -152,5 +166,5 @@
   int spec = 1 + (int) ( ((double) SPEC_MAX)* ((double) random())/(RAND_MAX + 1.0));
 #else
-  int spec = random() + 1;
+  unsigned long spec = random() + 1;
 #endif  
   if (! size_range_number)
@@ -167,5 +181,5 @@
 
 
-void TestAlloc(omMemCell cell, int spec)
+void TestAlloc(omMemCell cell, unsigned long spec)
 {
   if (DO_CHECK(spec))
@@ -187,5 +201,5 @@
 }
 
-void TestRealloc(omMemCell cell, int spec)
+void TestRealloc(omMemCell cell, unsigned long spec)
 {
   if (DO_CHECK(spec))
@@ -207,5 +221,5 @@
 }
 
-void TestDup(omMemCell cell, int spec)
+void TestDup(omMemCell cell, unsigned long spec)
 {
   if (DO_CHECK(spec))
@@ -269,5 +283,5 @@
 {
   int i=0, error_test = 1;
-  int spec, j;
+  unsigned long spec, j;
   int n = 1;
   int n_cells = MAX_CELLS;
@@ -340,5 +354,5 @@
     }
     spec = MyRandSpec();
-    myprintf("%d:%d:%d:%d", i, spec, GET_SIZE(spec), GET_TRACK(spec));
+    myprintf("%d:%lu:%ld:%ld", i, spec, GET_SIZE(spec), GET_TRACK(spec));
     myfflush(stdout);
     if (DO_FREE(spec))
@@ -348,5 +362,5 @@
         myprintf(" FREE");
         j = spec % i;
-        myprintf(" %d ", j);
+        myprintf(" %ld ", j);
         myfflush(stdout);
         TestFree(&cells[j]);
@@ -360,5 +374,5 @@
         myprintf(" REALLOC");
         j = spec % i;
-        myprintf(" %d ", j);
+        myprintf(" %ld ", j);
         myfflush(stdout);
         TestRealloc(&cells[j], spec);
@@ -371,5 +385,5 @@
         myprintf(" DUP");
         j = spec % i;
-        myprintf(" %d ", j);
+        myprintf(" %ld ", j);
         myfflush(stdout);
         TestDup(&cells[j], spec);
Index: omalloc/omtTest.h
===================================================================
--- omalloc/omtTest.h	(revision 682c0fc669c618482ee7213a8a2e691bed6a4d54)
+++ omalloc/omtTest.h	(revision 78f1abdf266970a5405d91d6d5ff1bb269c7cb34)
@@ -21,5 +21,5 @@
   void* addr;
   omBin bin;
-  int spec;
+  unsigned long spec;
 };
 
@@ -28,6 +28,6 @@
 
 extern omMemCell_t cells[];
-void TestAlloc(omMemCell cell, int spec);
-void TestRealloc(omMemCell cell, int spec);
+void TestAlloc(omMemCell cell, unsigned long spec);
+void TestRealloc(omMemCell cell, unsigned long spec);
 void TestFree(omMemCell cell);
 
@@ -80,22 +80,22 @@
 #define PAGES_PER_REGION 128
 
-void omTestAlloc(omMemCell cell, int spec);
-void omTestRealloc(omMemCell cell, int spec);
-void omTestDup(omMemCell cell, int spec);
-void omTestFree(omMemCell cell);
+void omtTestAlloc(omMemCell cell, unsigned long spec);
+void omtTestRealloc(omMemCell cell, unsigned long spec);
+void omtTestDup(omMemCell cell, unsigned long spec);
+void omtTestFree(omMemCell cell);
 
-void omTestAllocDebug(omMemCell cell, int spec);
-void omTestReallocDebug(omMemCell cell, int spec);
-void omTestDupDebug(omMemCell cell, int spec);
-void omTestFreeDebug(omMemCell cell);
+void omtTestAllocDebug(omMemCell cell, unsigned long spec);
+void omtTestReallocDebug(omMemCell cell, unsigned long spec);
+void omtTestDupDebug(omMemCell cell, unsigned long spec);
+void omtTestFreeDebug(omMemCell cell);
 void InitCellAddrContent(omMemCell cell);
-int omTestErrors();
+int omtTestErrors();
 
 #if CHECK_LEVEL > 0
-void omTestDebug(omMemCell cell);
+void omtTestDebug(omMemCell cell);
 void TestAddrContent(void* addr, unsigned long value, size_t size);
 void TestAddrContentEqual(void* s1, void* s2, size_t size);
 #else
-#define omTestDebug(cell)               ((void)0)
+#define omtTestDebug(cell)               ((void)0)
 #define TestAddrContent(a,v,s)          ((void)0)
 #define TestAddrContentEqual(s1, s2, s) ((void)0)
Index: omalloc/omtTestAlloc.c
===================================================================
--- omalloc/omtTestAlloc.c	(revision 682c0fc669c618482ee7213a8a2e691bed6a4d54)
+++ omalloc/omtTestAlloc.c	(revision 78f1abdf266970a5405d91d6d5ff1bb269c7cb34)
@@ -4,5 +4,5 @@
  *  Author:  obachman@mathematik.uni-kl.de (Olaf Bachmann)
  *  Created: 11/99
- *  Version: $Id: omtTestAlloc.c,v 1.3 2000-08-14 12:26:52 obachman Exp $
+ *  Version: $Id: omtTestAlloc.c,v 1.4 2000-08-18 09:02:02 obachman Exp $
  *******************************************************************/
 #include "omtTest.h"
@@ -22,5 +22,5 @@
 #endif
 
-void omtTestAlloc(omMemCell cell, int spec)
+void omtTestAlloc(omMemCell cell, unsigned long spec)
 {
   int size = GET_SIZE(spec);
@@ -119,5 +119,5 @@
 {
   void* addr = cell->addr;
-  int spec = cell->spec;
+  unsigned long spec = cell->spec;
   omBin bin = cell->bin;
   size_t size = GET_SIZE(spec);
@@ -150,5 +150,5 @@
 }
 
-void omtTestRealloc(omMemCell cell, int new_spec)
+void omtTestRealloc(omMemCell cell, unsigned long new_spec)
 {
   void* old_addr = cell->addr;
@@ -304,5 +304,5 @@
 
 #define DO_STRDUP(l) (l & 1)
-void omtTestDup(omMemCell cell, int spec)
+void omtTestDup(omMemCell cell, unsigned long spec)
 {
   omtTestDebug(cell);